Usage with Python interface
======================

The driver VsxProtocolDriver (VsxSdk) facilitates integration in a Python-
based programming environment.

The main driver is implemented in C# and requires .NET 6.0 or higher. Python accesses
the fuctionality via the C-wrapper interface.

The functions of the Python-wrapper can only be used synchronously.

## Requirements
The driver is available as Python library and header for multiple architecture
 * Windows 64 bit / 32 bit
 * Linux AMD64, ARM64, ARM32

Python should be at least 3.9.

The driver is based on the VsxProtocolDriver, which is based on C#.
So for usage the Microsoft .NET Runtime 6.0.x framework or higher must be installed (See https://dotnet.microsoft.com/en-us/download/dotnet).
There is also still support for .Net 5.0, but this will propably be dropped in the next version.

## Installation
In order to use the SDK, the file are located inside the folder `Python\package` as an zipped package file.

Install with pip:
```sh
pip install VsxProtocolDriver-<x.x.x>.tar.gz 
```

## Usage

The main entry is the class `VsxProtocolDriver.Sensor`, where the functions to detect sensors on the network and the initialization of the
sensor (`InitTcpSensor` and `InitSerialSensor`) are located.
