Examples
========

In the following the usage of the `VsxProtocolDriver` is shown with a short code example. 

The complete examples can be found as a CMake project in the `Python\example\` subfolder.
It support the detection of different sensors and show the parametrization and the grabbing of data from the sensor.


```python
### Example TCP/IP
import VsxProtocolDriver

ret, devices = VsxProtocolDriver.Sensor.GetUdpDeviceList()

if len(devices) > 0:
    sensor = VsxProtocolDriver.Sensor.InitTcpSensor(devices[0]["ipAddress"], "")
else:
    sensor = VsxProtocolDriver.Sensor.InitTcpSensor("192.168.2.4", "")
    
ret = sensor.Connect()

# Optional login
ret = sensor.Login("<user>", "<password>")

ret, exposure_time = sensor.GetSingleParameterValue(1, "Base", 1, "ExposureTime")

ret = sensor.Disconnect()
```
