Device parameter
================

In this chapter some information about the structure of the device parameters shall be given.

The device parameters are organized in two levels. The first level includes one or more configuration groups. Each of these configuration groups in turn contains one or more parameters.
To uniquely identify parameters, each configuration has a unique Id. Each parameter also contains an Id that is unique within its configuration.

In order to keep different firmware versions compatible with each other, an additional versioning exists. This comprises on the one hand a settings version, which determines, 
which configurations are present up-to-date, and a configuration version, which determines which parameters are present at the moment in this configuration.
If changes are made to configurations or parameters, the respective version number is increased.

Four arguments are hence required to uniquely define a device parameter:
* _settingsVersion_: Version number, which tells the device which configurations are available
* _configurationId_: Id of the current configuration group
* _configurationVersion_: Version number, which tells the device which parameters are available whithin the current configuration group and how they are handled
* _parameterId_: Id of the current parameter

In order to know the individual parameters with their ids and versions, files for all supported sensor types and their various firmware versions are stored 
in a source file in the example subfolder named with `<sensor_name>ParameterIdentifier`. The required informations can be taken from these files.

**Example**: The value of the following parameter for the Smartrunner 3-D device:
* _settingsVersion_: 2
* _configurationId_: "Base"
* _configurationVersion_: 2
* _parameterId_: "ExposureTime"

can be received using the driver via the function ```GetSingleParameterValue(settingsVersion:2, configId:"Base", configVersion:2, parameterId:"ExposureTime")```.

**Additional notes:**
* if a configuration or parameter does not contain a version attribute, use the default value of "1".
* in addition to the information on version and Id, the xml files also contain further information on the parameters such as name, value range, etc.
* to trigger event parameters these must be set to a value of "1".
* for the Smartrunner 2-D, only a part of the parameters is listed in the corresponding xml file. Only these parameters should be used for parameterization of the device.


