from enum import IntEnum


class SerialConnectionType(IntEnum):
    USB_SSI = 0
    PROFIBUS = 1
    PROFINET = 2
    ETHERNET_IP = 3
    RS485 = 4
    CANOPEN = 5


class Strategy(IntEnum):
    DROP_OLDEST = 0
    DROP_WRITE = 1


class DeviceStatusScope(IntEnum):
    FULL = 0
    MULTI = 1


class DisconnectEvent(IntEnum):
    REMOTE_HOST_CONNECTION_CLOSED = 0
    DISCONNECT_CALLED = 1
    CONNECTION_ERROR = 2


class SessionTypes(IntEnum):
    LOGIN_REQUIRED = 0
    INITIAL_PASSWORD_REQUIRED = 1
    LOGIN = 2
    LOGIN_REPLY = 3
    SET_PASSWORD = 4
    SET_PASSWORD_REPLY = 5
    TIMEOUT_ANNOUNCEMENT = 6
    TIMEOUT = 7
    LOGOUT = 8
    LOGOUT_REPLY = 9
    UNKNOWN = 10


class ValueType(IntEnum):
    BOOL = 0
    INT = 1
    LONG = 2
    UINT = 3
    INT16 = 4
    FLOAT = 5
    DOUBLE = 6
    STRING = 7
    HEXSTRING = 8
    BASE64 = 9
    ENUM = 10
    IP = 11
    RECTANGLE = 12
    QUAD = 13
    POINT = 14
    UNKNOWN = 15


class StatusCode(IntEnum):
    VSX_STATUS_SUCCESS = 0
    VSX_STATUS_ERROR_DRIVER_INIT = -0x1
    VSX_STATUS_ERROR_DRIVER_TIMEOUT = -0x2
    VSX_STATUS_ERROR_DRIVER_SAVE_FILE = -0x3
    VSX_STATUS_ERROR_DRIVER_DATA = -0x4
    VSX_STATUS_ERROR_DRIVER_CONNECTION = -0x5
    VSX_STATUS_ERROR_DRIVER_INVALID_DATA = -0x6
    VSX_STATUS_ERROR_DRIVER_DEVICE = -0x7
    VSX_STATUS_ERROR_DRIVER_LOAD_FILE = -0x8
    VSX_STATUS_ERROR_SESSION = -0x9
    VSX_STATUS_ERROR_STRING = -0x0A
    VSX_STATUS_ERROR_VERSION = -0x0B
    VSX_STATUS_ERROR_DRIVER_GENERAL = -0x1000
    VSX_STATUS_ERROR_UNABLE_TO_ALLOCATE_VSX_SYSTEM = -0x8001
    VSX_STATUS_ERROR_VSX_SYSTEM_HANDLE_NOT_ZERO = -0x8002
    VSX_STATUS_ERROR_VSX_SYSTEM_HANDLE_ZERO = -0x8003
    VSX_STATUS_ERROR_VSX_SYSTEM_HANDLE_NOT_AVAILABLE = -0x8004
    VSX_STATUS_ERROR_MISSING_IP_ADDRESS_DECLARATION = -0x8005
    VSX_STATUS_ERROR_MISSING_SERIALPORT_DECLARATION = -0x8006
    VSX_STATUS_ERROR_VSX_SYSTEM_HANDLE_POINTER_ZERO = -0x8007
    VSX_STATUS_ERROR_CONFIGURATION_ID_ZERO = -0x8008
    VSX_STATUS_ERROR_PARAMETER_ID_ZERO = -0x8009
    VSX_STATUS_ERROR_VALUE_ZERO = -0x800A
    VSX_STATUS_ERROR_COMMAND_ZERO = -0x800B
    VSX_STATUS_ERROR_INPUT_VALUE_ZERO = -0x800C
    VSX_STATUS_ERROR_OUTPUT_VALUE_POINTER_ZERO = -0x800D
    VSX_STATUS_ERROR_OUTPUT_VALUE_NOT_ZERO = -0x800E
    VSX_STATUS_ERROR_VALUE_POINTER_ZERO = -0x800F
    VSX_STATUS_ERROR_VALUE_NOT_ZERO = -0x8010
    VSX_STATUS_ERROR_UNABLE_TO_FIND_VSX_SYSTEM = -0x8011
    VSX_STATUS_ERROR_XML_COMMAND_ZERO = -0x8012
    VSX_STATUS_ERROR_FILENAME_ZERO = -0x8013
    VSX_STATUS_ERROR_STRING_POINTER_ZERO = -0x8014
    VSX_STATUS_ERROR_STRING_ZERO = -0x8015
    VSX_STATUS_ERROR_VSX_DATA_CONTAINER_HANDLE_POINTER_ZERO = -0x8016
    VSX_STATUS_ERROR_UNABLE_TO_ALLOCATE_VSX_DATA_CONTAINER = -0x8017
    VSX_STATUS_ERROR_VSX_DATA_CONTAINER_HANDLE_NOT_ZERO = -0x8018
    VSX_STATUS_ERROR_VSX_DATA_CONTAINER_HANDLE_ZERO = -0x8019
    VSX_STATUS_ERROR_VSX_DATA_CONTAINER_HANDLE_NOT_AVAILABLE = -0x801A
    VSX_STATUS_ERROR_IMAGE_TAG_ZERO = -0x801B
    VSX_STATUS_ERROR_UNABLE_TO_FIND_VSX_DATA_CONTAINER = -0x801C
    VSX_STATUS_ERROR_UNABLE_TO_FIND_IMAGE_ID_IN_DATA_CONTAINER = -0x801D
    VSX_STATUS_ERROR_UNABLE_TO_FIND_IMAGE_TAG_TO_DATA_FORMAT = -0x801E
    VSX_STATUS_ERROR_POINT_Z_ID_ZERO = -0x801F
    VSX_STATUS_ERROR_POINT_Y_ID_ZERO = -0x8020
    VSX_STATUS_ERROR_POINT_X_ID_ZERO = -0x8021
    VSX_STATUS_ERROR_UNABLE_TO_FIND_POINT_X_ID_IN_DATA_CONTAINER = -0x8022
    VSX_STATUS_ERROR_UNABLE_TO_FIND_POINT_Y_ID_IN_DATA_CONTAINER = -0x8023
    VSX_STATUS_ERROR_UNABLE_TO_FIND_POINT_Z_ID_IN_DATA_CONTAINER = -0x8024
    VSX_STATUS_ERROR_UNABLE_TO_FIND_POINT_X_ID_TO_DATA_FORMAT = -0x8025
    VSX_STATUS_ERROR_UNABLE_TO_FIND_POINT_Y_ID_TO_DATA_FORMAT = -0x8026
    VSX_STATUS_ERROR_UNABLE_TO_FIND_POINT_Z_ID_TO_DATA_FORMAT = -0x8027
    VSX_STATUS_ERROR_LOG_POINTER_ZERO = -0x8028
    VSX_STATUS_ERROR_LOG_NOT_ZERO = -0x8029
    VSX_STATUS_ERROR_RESULT_NOT_ZERO = -0x802A
    VSX_STATUS_ERROR_RESULT_POINTER_ZERO = -0x802B
    VSX_STATUS_ERROR_UNABLE_TO_FIND_RESULT_ID_IN_DATA_CONTAINER = -0x802C
    VSX_STATUS_ERROR_UNABLE_TO_FIND_RESULT_ID_TO_DATA_FORMAT = -0x802D
    VSX_STATUS_ERROR_VERSION_POINTER_ZERO = -0x802E
    VSX_STATUS_ERROR_VERSION_NOT_ZERO = -0x802F
    VSX_STATUS_ERROR_VSX_IMAGE_POINTER_ZERO = -0x8030
    VSX_STATUS_ERROR_VSX_IMAGE_NOT_ZERO = -0x8031
    VSX_STATUS_ERROR_UNDEFINED_STRATEGY_VALUE = -0x8032
    VSX_STATUS_ERROR_UNDEFINED_CONNECTION_TYPE_VALUE = -0x8033
    VSX_STATUS_ERROR_XPATH_ZERO = -0x8034
    VSX_STATUS_ERROR_INVALID_DATA_FORMAT = -0x8035
    VSX_STATUS_ERROR_NO_ELEMENT_FOUND = -0x8036
    VSX_STATUS_ERROR_RESULT_TAG_ZERO = -0x8037
    VSX_STATUS_ERROR_TAG_ZERO = -0x8038
    VSX_STATUS_ERROR_UNABLE_TO_FIND_TAG_IN_DATA_CONTAINER = -0x8039
    VSX_STATUS_ERROR_IP_ADDRESS_ZERO = -0x803A
    VSX_STATUS_ERROR_NETWORK_MASK_ZERO = -0x803B
    VSX_STATUS_ERROR_GATEWAY_ZERO = -0x803C
    VSX_STATUS_ERROR_EXCEPTION_THROWN = -0x803D
    VSX_STATUS_ERROR_VSX_DEVICE_POINTER_ZERO = -0x803E
    VSX_STATUS_ERROR_VSX_DEVICE_NOT_ZERO = -0x803F
    VSX_STATUS_ERROR_VSX_IMAGE_ZERO = -0x8040
    VSX_STATUS_ERROR_VSX_DEVICE_ZERO = -0x8041
    VSX_STATUS_ERROR_VSX_DEVICE_LIST_POINTER_ZERO = -0x8042
    VSX_STATUS_ERROR_VSX_DEVICE_LIST_ZERO = -0x8043
    VSX_STATUS_ERROR_VSX_TAG_LIST_ZERO = -0x8044
    VSX_STATUS_ERROR_VSX_TAG_LIST_POINTER_ZERO = -0x8045
    VSX_STATUS_ERROR_VSX_TAG_LIST_NOT_ZERO = -0x8046
    VSX_STATUS_ERROR_VSX_PARAMETER_LIST_POINTER_ZERO = -0x8047
    VSX_STATUS_ERROR_VSX_PARAMETER_LIST_ZERO = -0x8048
    VSX_STATUS_ERROR_VSX_PARAMETER_NOT_ZERO = -0x8049
    VSX_STATUS_ERROR_VSX_STATUS_ITEM_LIST_POINTER_ZERO = -0x804A
    VSX_STATUS_ERROR_VSX_STATUS_ITEM_LIST_ZERO = -0x804B
    VSX_STATUS_ERROR_VSX_STATUS_ITEM_NOT_ZERO = -0x0804C
    VSX_STATUS_ERROR_ERROR_TEXT_POINTER_ZERO = -0x0804D
    VSX_STATUS_ERROR_ERROR_TEXT_NOT_ZERO = -0x0804E
    VSX_STATUS_ERROR_ON_DISCONNECT_CALLBACK_ZERO = -0x0804F
    VSX_STATUS_ERROR_MAC_ADDRESS_ZERO = -0x08050
    VSX_STATUS_ERROR_VSX_CACHED_CONTAINER_NOT_FOUND = -0x08051
    VSX_STATUS_ERROR_VSX_PARAMETER_LIST_NOT_ZERO = -0x08052
    VSX_STATUS_ERROR_VSX_PARAMETER_POINTER_ZERO = -0x08053
    VSX_STATUS_ERROR_VSX_PARAMETER_ZERO = -0x08054
    VSX_STATUS_ERROR_VSX_DISPARITY_DESCRIPTOR2_POINTER_ZERO = -0x08055
    VSX_STATUS_ERROR_UNABLE_TO_FIND_DISPARITY_DESCRIPTOR2_TAG = -0x08056
    VSX_STATUS_ERROR_UNABLE_TO_FIND_DISPARITY_DESCRIPTOR2_ID_IN_DATA_CONTAINER = -0x08057
    VSX_STATUS_ERROR_VSX_DISPARITY_DESCRIPTOR2_NOT_ZERO = -0x08058
    VSX_STATUS_ERROR_VSX_DISPARITY_DESCRIPTOR2_ZERO = -0x08059
    VSX_STATUS_ERROR_VSX_TRANSFORMATION_POINTER_ZERO = -0x0805A
    VSX_STATUS_ERROR_UNABLE_TO_FIND_TRANSFORMATION_ID_IN_DATA_CONTAINER = -0x0805B
    VSX_STATUS_ERROR_UNABLE_TO_FIND_TRANSFORMATION_TAG = -0x0805C
    VSX_STATUS_ERROR_VSX_TRANSFORMATION_NOT_ZERO = -0x0805D
    VSX_STATUS_ERROR_VSX_TRANSFORMATION_ZERO = -0x0805E
    VSX_STATUS_ERROR_UNABLE_TO_FIND_CAPTURE_INFORMATION_TAG = -0x0805F
    VSX_STATUS_ERROR_UNABLE_TO_FIND_CAPTURE_INFORMATION_ID_IN_DATA_CONTAINER = -0x08060
    VSX_STATUS_ERROR_VSX_CAPTURE_INFORMATION_POINTER_ZERO = -0x08061
    VSX_STATUS_ERROR_VSX_CAPTURE_INFORMATION_NOT_ZERO = -0x08062
    VSX_STATUS_ERROR_VSX_CAPTURE_INFORMATION_ZERO = -0x08063
    VSX_STATUS_ERROR_VSX_LINE_DATA_POINTER_ZERO = -0x08064
    VSX_STATUS_ERROR_LINE_DATA_TAG_ZERO = -0x08065
    VSX_STATUS_ERROR_UNABLE_TO_FIND_LINE_ID_IN_DATA_CONTAINER = -0x08066
    VSX_STATUS_ERROR_UNABLE_TO_FIND_LINE_TAG_TO_DATA_FORMAT = -0x08067
    VSX_STATUS_ERROR_VSX_LINE_NOT_ZERO = -0x08068
    VSX_STATUS_ERROR_VSX_LINE_DATA_ZERO = -0x08069
    VSX_STATUS_ERROR_MISSING_LOGIN_PASSWORD = -0x0806A
    VSX_STATUS_ERROR_MISSING_LOGIN_USERNAME = -0x0806B
    VSX_STATUS_ERROR_ON_SESSION_MESSAGE_RECEIVED_CALLBACK_ZERO = -0x0806C


class StatusItem:
    def __init__(self, settings_version: int, configuration_class: str, config_version: int, status_item_id: str,
                 name: str, value: object, value_type: ValueType, time: int, sensor_time: int):
        self.settingsVersion = settings_version
        self.configurationClass = configuration_class
        self.configVersion = config_version
        self.statusItemId = status_item_id
        self.name = name
        self.value = value
        self.valueType = value_type
        self.time = time
        self.sensorTime = sensor_time


class Parameter:
    def __init__(self, settings_version: int, config_id: str, config_version: int, parameter_id: str, name: str,
                 value: object, value_type: ValueType, enum_items: dict):
        self.settingsVersion = settings_version
        self.configId = config_id
        self.configVersion = config_version
        self.parameterId = parameter_id
        self.name = name
        self.value = value
        self.valueType = value_type
        self.enumItems = enum_items
