﻿
#include <PF.VsxProtocolDriver.WrapperNE.h>

#include "VsxProtocolDriverDemo.h"

static const std::vector<const char*> TriggerSourceItems = { "AutoTrigger", "Line1", "Software" };
static const std::vector<const char*> TriggerActivationItems = { "FallingEdge", "RisingEdge" };
static const std::vector<const char*> BinningModeItems = { "FallingEdge", "RisingEdge" };
static const std::vector<const char*> RangeModeItems = { "1500", "3750", "7500" };
static const std::vector<const char*> OutputModeItems = { "CalibratedABC_Grid", "CalibratedABC_Grid_Amp", "CalibratedC", "CalibratedC_Amp", "DistAmp", "Distance" };
static const std::vector<const char*> CameraModeItems = { "FastMovement", "HighDynamic", "Standard" };


static const ParameterElement TriggerSource = { "Base", "TriggerSource", TriggerSourceItems };
static const ParameterElement OutputMode = { "Base", "OutputMode", OutputModeItems };
static const ParameterElement AutoTriggerFrameRate = { "Base", "AutoTriggerFrameRate", {} };
static const ParameterElement RangeMode = { "Base", "RangeMode", RangeModeItems };
static const ParameterElement TemporalFilter = { "Base", "TemporalFilter", {} };
static const ParameterElement ExposureTime = { "Base", "ExposureTime", {} };
static const ParameterElement TriggerEnabled = { "Base", "TriggerEnabled", {} };
static const ParameterElement CameraMode = { "Base", "CameraMode", CameraModeItems };
static const ParameterElement BinningMode = { "Base", "BinningMode", BinningModeItems };
static const ParameterElement MinimumAmplitude = { "Base", "MinimumAmplitude", {} };
static const ParameterElement TriggerActivation = { "Base", "TriggerActivation", TriggerActivationItems };
static const ParameterElement FlyingPixelFilterEnabled = { "Base", "FlyingPixelFilterEnabled", {} };
static const ParameterElement SpatialFilterEnabled = { "Base", "SpatialFilterEnabled", {} };
static const ParameterElement VendorName = { "General", "VendorName", {} };
static const ParameterElement VendorUrl = { "General", "VendorUrl", {} };
static const ParameterElement ProductName = { "General", "ProductName", {} };
static const ParameterElement ProductClass = { "General", "ProductClass", {} };
static const ParameterElement PartNumber = { "General", "PartNumber", {} };
static const ParameterElement SerialNumber = { "General", "SerialNumber", {} };
static const ParameterElement FirmwareVersion = { "General", "FirmwareVersion", {} };
static const ParameterElement HardwareVersion = { "General", "HardwareVersion", {} };
static const ParameterElement UniqueProductID = { "General", "UniqueProductID", {} };
static const ParameterElement ApplicationSpecificTag = { "General", "ApplicationSpecificTag", {} };
static const ParameterElement FunctionTag = { "General", "FunctionTag", {} };
static const ParameterElement LocationTag = { "General", "LocationTag", {} };
static const ParameterElement TriggerSoftware = { "Command", "TriggerSoftware", {} };
static const ParameterElement GetLicenses = { "Command", "GetLicenses", {} };
