﻿namespace VsxProtocolDriverDemo
{
    // This example programs connects with the device, gets device informations and all parameters and starts grabbing 3D data
    static class ExampleSr3DStereo
    {
        public static async Task RunExample()
        {
            // Get complete parameter list
            var paramRes = await Program._vsxProtocolDriver.GetParameterList();
            if (paramRes.Succ)
            {
                Console.WriteLine($"--- Device contains the following parameters: ---");
                for (int i = 0; i < paramRes.ParameterList.Count; i++)
                {
                    Console.WriteLine($"Id: {paramRes.ParameterList[i].ParameterId}, Name: {paramRes.ParameterList[i].Name}, " +
                        $"Value: {paramRes.ParameterList[i].Value}");
                }
            }
            else
            {
                Console.WriteLine($"Unable to receive parameter list: {paramRes.ErrorDesc?.Message}");
                return;
            }

            // Start autotrigger and enable trigger, see manual for config Id and parameter Id
            var setParamResult = await Program._vsxProtocolDriver.SetSingleParameterValue(Sr3DParameterIdentifierStereo.TriggerSource.SettingsVersion, Sr3DParameterIdentifierStereo.TriggerSource.ConfigVersion, Sr3DParameterIdentifierStereo.TriggerSource.ConfigId, Sr3DParameterIdentifierStereo.TriggerSource.ParamId, Sr3DParameterIdentifierStereo.TriggerSource.Items[0]);
            setParamResult = await Program._vsxProtocolDriver.SetSingleParameterValue(Sr3DParameterIdentifierStereo.TriggerEnabled.SettingsVersion, Sr3DParameterIdentifierStereo.TriggerEnabled.ConfigVersion, Sr3DParameterIdentifierStereo.TriggerEnabled.ConfigId, Sr3DParameterIdentifierStereo.TriggerEnabled.ParamId, 1);

            // Alternative:
            //param = paramRes.ParameterList.Find(x => x.ConfigId == Sr3DParameterIdentifierStereo.TriggerEnabled.ConfigId && x.ParameterId == Sr3DParameterIdentifierStereo.TriggerEnabled.ParamId); // start trigger
            //setParamResult = await Program._vsxProtocolDriver.SetSingleParameterValue(param, "1");

            // Set output format to disparity, then you get the data needed from device
            setParamResult = await Program._vsxProtocolDriver.SetSingleParameterValue(Sr3DParameterIdentifierStereo.OutputMode.SettingsVersion, Sr3DParameterIdentifierStereo.OutputMode.ConfigVersion, Sr3DParameterIdentifierStereo.OutputMode.ConfigId, Sr3DParameterIdentifierStereo.OutputMode.ParamId, Sr3DParameterIdentifierStereo.OutputMode.Items[1]);
        }

    }
}
