﻿namespace VsxProtocolDriverDemo
{
    // This example programs connects with the device, gets device informations and all parameters and starts grabbing 3D data
    static class ExampleSr3DTof
    {
        public static async Task RunExample()
        {
            // Get complete parameter list
            var paramRes = await Program._vsxProtocolDriver.GetParameterList();
            if (paramRes.Succ)
            {
                Console.WriteLine($"--- Device contains the following parameters: ---");
                for (int i = 0; i < paramRes.ParameterList.Count; i++)
                {
                    Console.WriteLine($"Id: {paramRes.ParameterList[i].ParameterId}, Name: {paramRes.ParameterList[i].Name}, " +
                        $"Value: {paramRes.ParameterList[i].Value}");
                }
            }
            else
            {
                Console.WriteLine($"Unable to receive parameter list: {paramRes.ErrorDesc?.Message}");
                return;
            }

            Console.WriteLine();
            Console.WriteLine("Press any key to start 3D data grabbing.");
            Console.ReadKey();

            // Start autotrigger and enable trigger, see manual for config Id and parameter Id
            var setParamResult = await Program._vsxProtocolDriver.SetSingleParameterValue(Sr3DParameterIdentifierTof.TriggerSource.SettingsVersion, Sr3DParameterIdentifierTof.TriggerSource.ConfigVersion, Sr3DParameterIdentifierTof.TriggerSource.ConfigId, Sr3DParameterIdentifierTof.TriggerSource.ParamId, Sr3DParameterIdentifierTof.TriggerSource.Items[0]);
            setParamResult = await Program._vsxProtocolDriver.SetSingleParameterValue(Sr3DParameterIdentifierTof.TriggerEnabled.SettingsVersion, Sr3DParameterIdentifierTof.TriggerEnabled.ConfigVersion, Sr3DParameterIdentifierTof.TriggerEnabled.ConfigId, Sr3DParameterIdentifierTof.TriggerEnabled.ParamId, 1);

            // Alternative:
            //var param = paramRes.ParameterList.Find(x => x.ConfigId == Sr3DParameterIdentifierTof.TriggerEnabled.ConfigId && x.ParameterId == Sr3DParameterIdentifierTof.TriggerEnabled.ParamId); // start trigger
            //var setParamResult = await Program._vsxProtocolDriver.SetSingleParameterValue(param, "1");

            // Set output format to disparity, then you get the data needed from device
            setParamResult = await Program._vsxProtocolDriver.SetSingleParameterValue(Sr3DParameterIdentifierTof.TriggerEnabled.SettingsVersion, Sr3DParameterIdentifierTof.TriggerEnabled.ConfigVersion, Sr3DParameterIdentifierTof.OutputMode.ConfigId, Sr3DParameterIdentifierTof.OutputMode.ParamId, Sr3DParameterIdentifierTof.OutputMode.Items[1]);

        }
    }
}
